/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.client.shared.model;

import java.util.List;

import org.dive4elements.river.client.client.ui.CollectionView;
import org.dive4elements.river.client.client.ui.NoopThemeRecordHandler;
import org.dive4elements.river.client.client.ui.OutputTab;
import org.dive4elements.river.client.client.ui.chart.ChartOutputTab;
import org.dive4elements.river.client.client.ui.chart.NaviChartOutputTab;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class ChartMode extends DefaultOutputMode {

    private static final long serialVersionUID = 1L;

    public ChartMode() {
    }

    public ChartMode(final String name, final String descrition, final String mimeType, final List<Facet> facets, final String type) {
        super(name, descrition, mimeType, facets);

        this.type = type;
    }

    /** Create output tab. Some outs feel better inside a specialized one. */
    @Override
    public OutputTab createOutputTab(final String t, final Collection c, final CollectionView p) {
        final String modeName = this.getName();

        if (modeName.equals("fix_wq_curve") || //
                modeName.equals("extreme_wq_curve") || //
                modeName.equals("fix_deltawt_curve") || //
                modeName.equals("fix_derivate_curve") || //
                modeName.equals("fix_vollmer_wq_curve") || //
                modeName.equals("sinfo_floodduration_curve")) {

            return new NaviChartOutputTab(t, c, this, p);
        }

        return new ChartOutputTab(t, c, this, p, new NoopThemeRecordHandler());
    }
}